| API Documentation |  |

- MAIN PAGE
- NAMESPACES
- CLASSES

Public Member Functions | List of all members
nkGraphics::ShaderMemorySlot Class Referenceabstract

A memory slot in a memory resource. More...

Inheritance diagram for nkGraphics::ShaderMemorySlot:

## Public Member Functions
| ShaderMemorySlot () noexcept
virtual | ~ShaderMemorySlot ()
nkMemory::StringView | getSlotType () const
virtual nkMemory::StringView | getDataTypeAsString () const =0
virtual void | exportClassToTree (nkExport::Node *rootNode) override
Public Member Functions inherited from nkExport::Exportable
| Exportable () noexcept
virtual | ~Exportable ()
virtual void | importClassFromTree (Node *rootNode)=0

## Detailed Description

A memory slot in a memory resource.

Conceptually, a memory buffer is made of slots filling information they are made for. For instance, a constant buffer will be able to receive pass slots, and each will feed a given variable in the buffer (view matrix, projection matrix...).

## Constructor & Destructor Documentation

## ◆ ShaderMemorySlot()

nkGraphics::ShaderMemorySlot::ShaderMemorySlot | ( |  | ) |
| noexcept

Constructor.

## ◆ ~ShaderMemorySlot()

virtual nkGraphics::ShaderMemorySlot::~ShaderMemorySlot | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ getSlotType()

nkMemory::StringView nkGraphics::ShaderMemorySlot::getSlotType | ( |  | ) | const

Returns
  The slot type.

## ◆ getDataTypeAsString()

virtual nkMemory::StringView nkGraphics::ShaderMemorySlot::getDataTypeAsString | ( |  | ) | const
| pure virtual

Returns
  The data type as a string.

Implemented in nkGraphics::ShaderPassMemorySlot, and nkGraphics::ShaderInstanceMemorySlot.

## ◆ exportClassToTree()

virtual void nkGraphics::ShaderMemorySlot::exportClassToTree | ( | nkExport::Node * | rootNode | ) |
| override virtual

Exports an item into a tree describing its structure and its data.

Parameters

  rootNode | The node into which the object has to write its related information.

Implements nkExport::Exportable.

Reimplemented in nkGraphics::ShaderPassMemorySlot, and nkGraphics::ShaderInstanceMemorySlot.

The documentation for this class was generated from the following file:

- Documentation/Headers/NilkinsGraphics/Shaders/Memory/ShaderMemorySlot.h